<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
	<div>
		<el-form :model="inputForm" ref="inputForm" v-loading="loading" :class="method==='view'?'readonly':''"
				 label-width="100px" @submit.native.prevent>

			<el-divider content-position="left"><i class="el-icon-document"></i> 基本信息</el-divider>
			<el-row :gutter="26">
				<el-col :span="12">
					<el-form-item label="姓名" prop="name" :rules="[{required: true, message: '姓名不能为空', trigger: 'blur'}]">
						<el-input v-model="inputForm.name" :disabled="true" ></el-input>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="所属部门" prop="department" :rules="[
						{required: true, message:'请选择所属部门', trigger: 'blur'}
					]">
						<SelectTree
							ref="officeTree"
							:props="{
										  value: 'id',             // ID字段名
										  label: 'name',         // 显示名称
										  children: 'children'    // 子级字段名
										}"
							:url="`/system-server/sys/office/treeData?type=2`"
							:value="inputForm.department"
							:disabled="true"
							:accordion="true"
							size="default"
							@getValue="(value) => {inputForm.department=value}"/>
					</el-form-item>
				</el-col>
			</el-row>
		</el-form>
	</div>
</template>

<script>
	import SelectTree from '@/components/treeSelect/treeSelect.vue'
	import handoverDraftService from '@/api/human/depart/HandoverDraftService'

	export default {
		props: {
			businessId: {
				type: String,
				default: ''
			},
			formReadOnly: {
				type: Boolean,
				default: false
			},
			status: {
				type: String,
				default: ''
			}
		},
		data () {
			return {
				title: '',
				method: '',
				visible: false,
				loading: false,
				inputForm: {
					userId: '',
					name: '',
					procInsId: '',
					assigneeId: '',
					type: '',
					department: '',
					handoverId: '',
				},
				keyWatch: '',
			}
		},
		created () {
		},
		components: {
			SelectTree,
		},
		computed: {
			bus: {
				get () {
					return this.businessId
				},
				set (val) {
					this.businessId = val
				}
			},
			name () {
				return this.$store.state.user.name
			},
			userId () {
				return this.$store.state.user.id
			}
		},
		watch: {
			'keyWatch': {
				handler (newVal) {
					if (this.commonJS.isNotEmpty(this.bus)) {
						this.init('', this.bus)
					} else {
						this.$nextTick(() => {
							this.$refs.inputForm.resetFields()
						})
					}
				}
			},
			'loading': {
				handler (newVal) {
					this.$emit('changeLoading', newVal)
				}
			}
		},
		methods: {
			getKeyWatch (keyWatch) {
				this.keyWatch = keyWatch
			},
			getUpload () {
			},
			init (method, id) {
				this.method = method
				this.inputForm = {
					userId: '',
					name: '',
					procInsId: '',
					assigneeId: '',
					type: '',
					department: '',
					handoverId: '',
				}
				if (method === 'add') {
					this.title = `新建底稿归档`
				} else if (method === 'edit') {
					this.title = '修改底稿归档信息'
				}
				this.inputForm.id = id
				this.visible = true
				this.loading = false
				this.$nextTick(() => {
					this.loading = true
					handoverDraftService.findById(this.inputForm.id).then( async (data) => {
						if (this.status === 'audit' || this.status === 'taskFormDetail') {
							method = 'view'
						}
						this.inputForm = this.recover(this.inputForm, data)
						this.inputForm = JSON.parse(JSON.stringify(this.inputForm))

						this.loading = false
					})
				})
			},
			// 表单提交
			doSubmit () {
				this.loading = true
				this.inputForm.id = this.businessId
				handoverDraftService.save(this.inputForm).then((data) => {
					this.close()
					this.$message.success(data)
					this.$emit('refreshDataList')
					this.loading = false
				}).catch(() => {
					this.loading = false
				})
			},
			close () {
				this.fileList = []
				this.fileList2 = []
				this.visible = false
			},
			reapplyForm (callback) {
				this.loading = true
				handoverDraftService.findById(this.inputForm.id).then((data) => {
					if (data.type !== '4') { // 审核状态不是“驳回”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
					} else {
						this.startForm(callback)
					}
				})
			},
			// 送审
			async startForm (callback) {
				this.loading = true
				this.inputForm.type = '2'
				handoverDraftService.save(this.inputForm).then((data) => {
					this.inputForm.title = `${this.$store.state.user.name} 发起了 [底稿归档检查]`
					this.inputForm.id = data.businessId
					this.inputForm.assignee = this.inputForm.draftAdministrator
					callback(data.businessTable, data.businessId, this.inputForm)
					this.loading = false
				}).catch(() => {
					this.loading = false
				})
			},

			// 通过
			async agreeForm (callback) {
				this.loading = true
				handoverDraftService.findById(this.inputForm.id).then((data) => {
					if (data.type !== '2') { // 审核状态不是“审核中”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
					} else {
						this.loading = true
						this.inputForm.type = '5'
						handoverDraftService.save(this.inputForm).then((data) => {
							callback(data.businessTable, data.businessId, this.inputForm)
							this.loading = false
						}).catch(() => {
							this.loading = false
						})
					}
				})
			},
			// 修改状态
			updateStatusById (type, callback) {
				if (type === 'reject') {
					this.loading = true
					handoverDraftService.findById(this.inputForm.id).then((data) => {
						if (data.type !== '2') { // 审核状态不是“审核中”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						} else {
							this.inputForm.type = '4'
							handoverDraftService.updateStatusById(this.inputForm).then(() => {
								this.loading = false
								callback(this.inputForm.assigneeId)
							})
						}
					})
				} else if (type === 'hold') {
					this.loading = true
					handoverDraftService.findById(this.inputForm.id).then((data) => {
						if (data.type !== '4') { // 审核状态不是“驳回”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						} else {
							this.inputForm.type = '1'
							handoverDraftService.updateStatusById(this.inputForm).then(() => {
								this.loading = false
								callback()
							})
						}
					})
				}
			},
		}
	}
</script>
